# coding: utf-8


"""
IGNORE:
    Nutanix Virtual Machine Management APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_vmm_py_client.models.catalogCommon.v1.config.CategoriesFilter import CategoriesFilter  # noqa: F401,E501
from ntnx_vmm_py_client.models.catalogCommon.v1.config.ContentPlacementType import ContentPlacementType  # noqa: F401,E501
from ntnx_vmm_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_vmm_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class CommonPlacementPolicy(ExternalizableAbstractModel):

    """Placement policy model.

    :param name: (:attr:`name`) Name of the placement policy.
    :type name: 
     min=1 chars, max=256 chars
    
    :param description: (:attr:`description`) Description of the placement policy.
    :type description: 
     max=1000 chars
    
    :param placement_type: (:attr:`placement_type`) 
    :type placement_type: 
    
    
    :param content_filter: (:attr:`content_filter`) 
    :type content_filter: 
    
    
    :param cluster_filter: (:attr:`cluster_filter`) 
    :type cluster_filter: 
    
    
    :param create_time: (:attr:`create_time`) The time when the placement policy was created.
    :type create_time: 
    
    
    :param update_time: (:attr:`update_time`) The time when the placement policy was last updated.
    :type update_time: 
    
    
    :param created_by: (:attr:`created_by`) External identifier of the user who created the placement policy.
    :type created_by: 
    
    
    :param updated_by: (:attr:`updated_by`) External identifier of the user who updated the placement policy.
    :type updated_by: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'placement_type': 'catalogCommon.v1.config.ContentPlacementType',
        'content_filter': 'catalogCommon.v1.config.CategoriesFilter',
        'cluster_filter': 'catalogCommon.v1.config.CategoriesFilter',
        'create_time': 'datetime',
        'update_time': 'datetime',
        'created_by': 'str',
        'updated_by': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'placement_type': 'placementType',
        'content_filter': 'contentFilter',
        'cluster_filter': 'clusterFilter',
        'create_time': 'createTime',
        'update_time': 'updateTime',
        'created_by': 'createdBy',
        'updated_by': 'updatedBy',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, description=None, placement_type=None, content_filter=None, cluster_filter=None, create_time=None, update_time=None, created_by=None, updated_by=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__description = None
        self.__placement_type = None
        self.__content_filter = None
        self.__cluster_filter = None
        self.__create_time = None
        self.__update_time = None
        self.__created_by = None
        self.__updated_by = None
        self.discriminator = None
        if name is not None:
            self.__name = name
        if description is not None:
            self.__description = description
        if placement_type is not None:
            self.__placement_type = placement_type
        if content_filter is not None:
            self.__content_filter = content_filter
        if cluster_filter is not None:
            self.__cluster_filter = cluster_filter
        if create_time is not None:
            self.__create_time = create_time
        if update_time is not None:
            self.__update_time = update_time
        if created_by is not None:
            self.__created_by = created_by
        if updated_by is not None:
            self.__updated_by = updated_by

    def _initialize_object_type(self):
        return 'catalogCommon.v1.config.CommonPlacementPolicy'

    def _initialize_object_version(self):
        return 'v1.r0'


    @property
    def name(self):
        """
        Name of the placement policy.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is not None and len(name) > 256:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `256`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__name = name

    @property
    def description(self):
        """
        Description of the placement policy.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")  # noqa: E501

        self.__description = description

    @property
    def placement_type(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.catalogCommon.v1.config.ContentPlacementType`
        """  # noqa: E501
        return self.__placement_type

    @placement_type.setter
    def placement_type(self, placement_type):

        self.__placement_type = placement_type

    @property
    def content_filter(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.catalogCommon.v1.config.CategoriesFilter`
        """  # noqa: E501
        return self.__content_filter

    @content_filter.setter
    def content_filter(self, content_filter):

        self.__content_filter = content_filter

    @property
    def cluster_filter(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.catalogCommon.v1.config.CategoriesFilter`
        """  # noqa: E501
        return self.__cluster_filter

    @cluster_filter.setter
    def cluster_filter(self, cluster_filter):

        self.__cluster_filter = cluster_filter

    @property
    def create_time(self):
        """
        The time when the placement policy was created.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__create_time

    @create_time.setter
    def create_time(self, create_time):

        self.__create_time = create_time

    @property
    def update_time(self):
        """
        The time when the placement policy was last updated.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__update_time

    @update_time.setter
    def update_time(self, update_time):

        self.__update_time = update_time

    @property
    def created_by(self):
        """
        External identifier of the user who created the placement policy.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__created_by

    @created_by.setter
    def created_by(self, created_by):
        if created_by is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', created_by):  # noqa: E501
            raise ValueError(r"Invalid value for `created_by`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__created_by = created_by

    @property
    def updated_by(self):
        """
        External identifier of the user who updated the placement policy.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        if updated_by is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', updated_by):  # noqa: E501
            raise ValueError(r"Invalid value for `updated_by`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__updated_by = updated_by

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(CommonPlacementPolicy, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CommonPlacementPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

