# coding: utf-8


"""
IGNORE:
    Nutanix Virtual Machine Management APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_vmm_py_client.models.catalogCommon.v1.config.CategoriesFilter import CategoriesFilter  # noqa: F401,E501
from ntnx_vmm_py_client.models.catalogCommon.v1.config.CommonPlacementPolicy import CommonPlacementPolicy  # noqa: F401,E501
from ntnx_vmm_py_client.models.catalogCommon.v1.config.ContentPlacementType import ContentPlacementType  # noqa: F401,E501

class TemplatePlacementPolicy(CommonPlacementPolicy):

    """

    :param phony: (:attr:`phony`) This readonly attribute is unused.
    :type phony: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'phony': 'str',
        'name': 'str',
        'description': 'str',
        'placement_type': 'catalogCommon.v1.config.ContentPlacementType',
        'content_filter': 'catalogCommon.v1.config.CategoriesFilter',
        'cluster_filter': 'catalogCommon.v1.config.CategoriesFilter',
        'create_time': 'datetime',
        'update_time': 'datetime',
        'created_by': 'str',
        'updated_by': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'phony': 'phony',
        'name': 'name',
        'description': 'description',
        'placement_type': 'placementType',
        'content_filter': 'contentFilter',
        'cluster_filter': 'clusterFilter',
        'create_time': 'createTime',
        'update_time': 'updateTime',
        'created_by': 'createdBy',
        'updated_by': 'updatedBy',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, phony=None, name=None, description=None, placement_type=None, content_filter=None, cluster_filter=None, create_time=None, update_time=None, created_by=None, updated_by=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        CommonPlacementPolicy.__init__(self, name, description, placement_type, content_filter, cluster_filter, create_time, update_time, created_by, updated_by, ext_id, links, tenant_id, *args, **kwargs)
        self.__phony = None
        self.discriminator = None
        if phony is not None:
            self.__phony = phony

    def _initialize_object_type(self):
        return 'vmm.v4.config.TemplatePlacementPolicy'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def phony(self):
        """
        This readonly attribute is unused.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__phony

    @phony.setter
    def phony(self, phony):

        self.__phony = phony

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(TemplatePlacementPolicy, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TemplatePlacementPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

