# coding: utf-8


"""
IGNORE:
    Nutanix Virtual Machine Management APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
import ntnx_vmm_py_client.models
from ntnx_vmm_py_client.models.OneOfvmm.v4.content.Ovachecksum import Ovachecksum  # noqa: F401,E501
from ntnx_vmm_py_client.models.OneOfvmm.v4.content.Ovasource import Ovasource  # noqa: F401,E501
from ntnx_vmm_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_vmm_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_vmm_py_client.models.iam.v4.authn.User import User  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.Vm import Vm  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.content.OvaDiskFormat import OvaDiskFormat  # noqa: F401,E501

class Ova(ExternalizableAbstractModel):

    """

    :param name: (:attr:`name`) Name of the OVA.
    :type name: required
     min=1 chars, max=256 chars
    
    :param checksum: (:attr:`checksum`) The checksum of an OVA.
    :type checksum: 
    
    
    :param size_bytes: (:attr:`size_bytes`) Size of OVA in bytes.
    :type size_bytes: 
    
     min=1,
    :param source: (:attr:`source`) Source of the created OVA file. The source can either be a VM, URL, or a local upload. 
    :type source: 
    
    
    :param create_time: (:attr:`create_time`) Time when the OVA was created time.
    :type create_time: 
    
    
    :param last_update_time: (:attr:`last_update_time`) Time when the OVA was last updated time.
    :type last_update_time: 
    
    
    :param created_by: (:attr:`created_by`) 
    :type created_by: 
    
    
    :param cluster_location_ext_ids: (:attr:`cluster_location_ext_ids`) List of cluster identifiers where the OVA is located. This field is required when creating an OVA from URL or Objects lite upload.
    :type cluster_location_ext_ids: 
    
    
    :param parent_vm: (:attr:`parent_vm`) The parent VM used for creating the OVA.
    :type parent_vm: 
    
    
    :param vm_config: (:attr:`vm_config`) 
    :type vm_config: 
    
    
    :param disk_format: (:attr:`disk_format`) 
    :type disk_format: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'checksum': 'OneOfvmm.v4.content.Ovachecksum',
        'size_bytes': 'int',
        'source': 'OneOfvmm.v4.content.Ovasource',
        'create_time': 'datetime',
        'last_update_time': 'datetime',
        'created_by': 'iam.v4.authn.User',
        'cluster_location_ext_ids': 'list[str]',
        'parent_vm': 'str',
        'vm_config': 'vmm.v4.ahv.config.Vm',
        'disk_format': 'vmm.v4.content.OvaDiskFormat',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'checksum': 'checksum',
        'size_bytes': 'sizeBytes',
        'source': 'source',
        'create_time': 'createTime',
        'last_update_time': 'lastUpdateTime',
        'created_by': 'createdBy',
        'cluster_location_ext_ids': 'clusterLocationExtIds',
        'parent_vm': 'parentVm',
        'vm_config': 'vmConfig',
        'disk_format': 'diskFormat',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, checksum=None, size_bytes=None, source=None, create_time=None, last_update_time=None, created_by=None, cluster_location_ext_ids=None, parent_vm=None, vm_config=None, disk_format=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__checksum = None
        self.__size_bytes = None
        self.__source = None
        self.__create_time = None
        self.__last_update_time = None
        self.__created_by = None
        self.__cluster_location_ext_ids = None
        self.__parent_vm = None
        self.__vm_config = None
        self.__disk_format = None
        self.discriminator = None
        self.__name = name
        if checksum is not None:
            self.__checksum = checksum
        if size_bytes is not None:
            self.__size_bytes = size_bytes
        if source is not None:
            self.__source = source
        if create_time is not None:
            self.__create_time = create_time
        if last_update_time is not None:
            self.__last_update_time = last_update_time
        if created_by is not None:
            self.__created_by = created_by
        if cluster_location_ext_ids is not None:
            self.__cluster_location_ext_ids = cluster_location_ext_ids
        if parent_vm is not None:
            self.__parent_vm = parent_vm
        if vm_config is not None:
            self.__vm_config = vm_config
        if disk_format is not None:
            self.__disk_format = disk_format

    def _initialize_object_type(self):
        return 'vmm.v4.content.Ova'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def name(self):
        """
        Name of the OVA.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 256:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `256`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__name = name

    @property
    def checksum(self):
        """
        The checksum of an OVA.

        :type:
                :class:`~ntnx_vmm_py_client.models.vmm.v4.content.OvaSha1Checksum` | 
                :class:`~ntnx_vmm_py_client.models.vmm.v4.content.OvaSha256Checksum`
        """  # noqa: E501
        return self.__checksum

    @checksum.setter
    def checksum(self, checksum):

        self.__checksum = checksum

    @property
    def size_bytes(self):
        """
        Size of OVA in bytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__size_bytes

    @size_bytes.setter
    def size_bytes(self, size_bytes):
        if size_bytes is not None and size_bytes < 1:  # noqa: E501
            raise ValueError("Invalid value for `size_bytes`, must be a value greater than or equal to `1`")  # noqa: E501

        self.__size_bytes = size_bytes

    @property
    def source(self):
        """
        Source of the created OVA file. The source can either be a VM, URL, or a local upload. 

        :type:
                :class:`~ntnx_vmm_py_client.models.vmm.v4.content.OvaUrlSource` | 
                :class:`~ntnx_vmm_py_client.models.vmm.v4.content.OvaVmSource` | 
                :class:`~ntnx_vmm_py_client.models.vmm.v4.content.ObjectsLiteSource`
        """  # noqa: E501
        return self.__source

    @source.setter
    def source(self, source):

        self.__source = source

    @property
    def create_time(self):
        """
        Time when the OVA was created time.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__create_time

    @create_time.setter
    def create_time(self, create_time):

        self.__create_time = create_time

    @property
    def last_update_time(self):
        """
        Time when the OVA was last updated time.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__last_update_time

    @last_update_time.setter
    def last_update_time(self, last_update_time):

        self.__last_update_time = last_update_time

    @property
    def created_by(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.iam.v4.authn.User`
        """  # noqa: E501
        return self.__created_by

    @created_by.setter
    def created_by(self, created_by):

        self.__created_by = created_by

    @property
    def cluster_location_ext_ids(self):
        """
        List of cluster identifiers where the OVA is located. This field is required when creating an OVA from URL or Objects lite upload.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__cluster_location_ext_ids

    @cluster_location_ext_ids.setter
    def cluster_location_ext_ids(self, cluster_location_ext_ids):

        self.__cluster_location_ext_ids = cluster_location_ext_ids

    @property
    def parent_vm(self):
        """
        The parent VM used for creating the OVA.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__parent_vm

    @parent_vm.setter
    def parent_vm(self, parent_vm):

        self.__parent_vm = parent_vm

    @property
    def vm_config(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.Vm`
        """  # noqa: E501
        return self.__vm_config

    @vm_config.setter
    def vm_config(self, vm_config):

        self.__vm_config = vm_config

    @property
    def disk_format(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.content.OvaDiskFormat`
        """  # noqa: E501
        return self.__disk_format

    @disk_format.setter
    def disk_format(self, disk_format):

        self.__disk_format = disk_format

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_vmm_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Ova, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Ova):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

